/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_TELUX_CV2X_CV2X_RADIO_TYPES_HPP_
#define V1_COMMONAPI_TELUX_CV2X_CV2X_RADIO_TYPES_HPP_



#include <v1/commonapi/telux/common/CommonDefines.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/Deployment.hpp>
#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Struct.hpp>
#include <CommonAPI/Types.hpp>
#include <cstdint>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

class Cv2xRadioTypes
: virtual public ::v1::commonapi::telux::common::CommonDefines {
public:
    virtual ~Cv2xRadioTypes() { }

    static inline const char* getInterface();
    static inline CommonAPI::Version getInterfaceVersion();
    
    struct TrafficCategory : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            SAFETY_TYPE = 0,
            NON_SAFETY_TYPE = 1
        };
    
        TrafficCategory()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::SAFETY_TYPE)) {}
        TrafficCategory(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::SAFETY_TYPE):
                case static_cast< uint8_t>(Literal::NON_SAFETY_TYPE):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const TrafficCategory &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const TrafficCategory &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const TrafficCategory &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const TrafficCategory &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const TrafficCategory &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const TrafficCategory &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::SAFETY_TYPE): return "SAFETY_TYPE";
            case static_cast< uint8_t>(Literal::NON_SAFETY_TYPE): return "NON_SAFETY_TYPE";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct Cv2xStatusType : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            INACTIVE = 0,
            ACTIVE = 1,
            SUSPENDED = 2,
            UNKNOWN = 3
        };
    
        Cv2xStatusType()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::INACTIVE)) {}
        Cv2xStatusType(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::INACTIVE):
                case static_cast< uint8_t>(Literal::ACTIVE):
                case static_cast< uint8_t>(Literal::SUSPENDED):
                case static_cast< uint8_t>(Literal::UNKNOWN):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const Cv2xStatusType &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const Cv2xStatusType &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const Cv2xStatusType &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const Cv2xStatusType &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const Cv2xStatusType &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const Cv2xStatusType &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::INACTIVE): return "INACTIVE";
            case static_cast< uint8_t>(Literal::ACTIVE): return "ACTIVE";
            case static_cast< uint8_t>(Literal::SUSPENDED): return "SUSPENDED";
            case static_cast< uint8_t>(Literal::UNKNOWN): return "UNKNOWN";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct Cv2xCauseType : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            TIMING = 0,
            CONFIG = 1,
            UE_MODE = 2,
            GEOPOLYGON = 3,
            THERMAL = 4,
            THERMNAL_ECALL = 5,
            GEOPOLYGON_SWITCH = 6,
            SENSING = 7,
            LPM = 8,
            DISABLED = 9,
            NO_GNSS = 10,
            INVALID_LICENSE = 11,
            UNKNOWN = 12
        };
    
        Cv2xCauseType()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::TIMING)) {}
        Cv2xCauseType(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::TIMING):
                case static_cast< uint8_t>(Literal::CONFIG):
                case static_cast< uint8_t>(Literal::UE_MODE):
                case static_cast< uint8_t>(Literal::GEOPOLYGON):
                case static_cast< uint8_t>(Literal::THERMAL):
                case static_cast< uint8_t>(Literal::THERMNAL_ECALL):
                case static_cast< uint8_t>(Literal::GEOPOLYGON_SWITCH):
                case static_cast< uint8_t>(Literal::SENSING):
                case static_cast< uint8_t>(Literal::LPM):
                case static_cast< uint8_t>(Literal::DISABLED):
                case static_cast< uint8_t>(Literal::NO_GNSS):
                case static_cast< uint8_t>(Literal::INVALID_LICENSE):
                case static_cast< uint8_t>(Literal::UNKNOWN):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const Cv2xCauseType &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const Cv2xCauseType &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const Cv2xCauseType &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const Cv2xCauseType &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const Cv2xCauseType &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const Cv2xCauseType &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::TIMING): return "TIMING";
            case static_cast< uint8_t>(Literal::CONFIG): return "CONFIG";
            case static_cast< uint8_t>(Literal::UE_MODE): return "UE_MODE";
            case static_cast< uint8_t>(Literal::GEOPOLYGON): return "GEOPOLYGON";
            case static_cast< uint8_t>(Literal::THERMAL): return "THERMAL";
            case static_cast< uint8_t>(Literal::THERMNAL_ECALL): return "THERMNAL_ECALL";
            case static_cast< uint8_t>(Literal::GEOPOLYGON_SWITCH): return "GEOPOLYGON_SWITCH";
            case static_cast< uint8_t>(Literal::SENSING): return "SENSING";
            case static_cast< uint8_t>(Literal::LPM): return "LPM";
            case static_cast< uint8_t>(Literal::DISABLED): return "DISABLED";
            case static_cast< uint8_t>(Literal::NO_GNSS): return "NO_GNSS";
            case static_cast< uint8_t>(Literal::INVALID_LICENSE): return "INVALID_LICENSE";
            case static_cast< uint8_t>(Literal::UNKNOWN): return "UNKNOWN";
            default: return "UNDEFINED";
            }
        }
    };
    struct Cv2xStatus : CommonAPI::Struct< Cv2xStatusType, Cv2xStatusType, Cv2xCauseType, Cv2xCauseType, uint8_t, bool> {
    
        Cv2xStatus()
        {
            std::get< 0>(values_) = Cv2xStatusType();
            std::get< 1>(values_) = Cv2xStatusType();
            std::get< 2>(values_) = Cv2xCauseType();
            std::get< 3>(values_) = Cv2xCauseType();
            std::get< 4>(values_) = 0u;
            std::get< 5>(values_) = false;
        }
        Cv2xStatus(const Cv2xStatusType &_rxStatus, const Cv2xStatusType &_txStatus, const Cv2xCauseType &_rxCause, const Cv2xCauseType &_txCause, const uint8_t &_cbrValue, const bool &_cbrValueValid)
        {
            std::get< 0>(values_) = _rxStatus;
            std::get< 1>(values_) = _txStatus;
            std::get< 2>(values_) = _rxCause;
            std::get< 3>(values_) = _txCause;
            std::get< 4>(values_) = _cbrValue;
            std::get< 5>(values_) = _cbrValueValid;
        }
        inline const Cv2xStatusType &getRxStatus() const { return std::get< 0>(values_); }
        inline void setRxStatus(const Cv2xStatusType &_value) { std::get< 0>(values_) = _value; }
        inline const Cv2xStatusType &getTxStatus() const { return std::get< 1>(values_); }
        inline void setTxStatus(const Cv2xStatusType &_value) { std::get< 1>(values_) = _value; }
        inline const Cv2xCauseType &getRxCause() const { return std::get< 2>(values_); }
        inline void setRxCause(const Cv2xCauseType &_value) { std::get< 2>(values_) = _value; }
        inline const Cv2xCauseType &getTxCause() const { return std::get< 3>(values_); }
        inline void setTxCause(const Cv2xCauseType &_value) { std::get< 3>(values_) = _value; }
        inline const uint8_t &getCbrValue() const { return std::get< 4>(values_); }
        inline void setCbrValue(const uint8_t &_value) { std::get< 4>(values_) = _value; }
        inline const bool &getCbrValueValid() const { return std::get< 5>(values_); }
        inline void setCbrValueValid(const bool _value) { std::get< 5>(values_) = _value; }
        inline bool operator==(const Cv2xStatus& _other) const {
        return (getRxStatus() == _other.getRxStatus() && getTxStatus() == _other.getTxStatus() && getRxCause() == _other.getRxCause() && getTxCause() == _other.getTxCause() && getCbrValue() == _other.getCbrValue() && getCbrValueValid() == _other.getCbrValueValid());
        }
        inline bool operator!=(const Cv2xStatus &_other) const {
            return !((*this) == _other);
        }
    
    };
    struct Cv2xPoolStatus : CommonAPI::Struct< uint8_t, Cv2xStatus> {
    
        Cv2xPoolStatus()
        {
            std::get< 0>(values_) = 0u;
            std::get< 1>(values_) = Cv2xStatus();
        }
        Cv2xPoolStatus(const uint8_t &_poolId, const Cv2xStatus &_status)
        {
            std::get< 0>(values_) = _poolId;
            std::get< 1>(values_) = _status;
        }
        inline const uint8_t &getPoolId() const { return std::get< 0>(values_); }
        inline void setPoolId(const uint8_t &_value) { std::get< 0>(values_) = _value; }
        inline const Cv2xStatus &getStatus() const { return std::get< 1>(values_); }
        inline void setStatus(const Cv2xStatus &_value) { std::get< 1>(values_) = _value; }
        inline bool operator==(const Cv2xPoolStatus& _other) const {
        return (getPoolId() == _other.getPoolId() && getStatus() == _other.getStatus());
        }
        inline bool operator!=(const Cv2xPoolStatus &_other) const {
            return !((*this) == _other);
        }
    
    };
    struct Cv2xStatusEx : CommonAPI::Struct< Cv2xStatus, std::vector< Cv2xPoolStatus >, bool, float> {
    
        Cv2xStatusEx()
        {
            std::get< 0>(values_) = Cv2xStatus();
            std::get< 1>(values_) = std::vector< Cv2xPoolStatus >();
            std::get< 2>(values_) = false;
            std::get< 3>(values_) = 0.0f;
        }
        Cv2xStatusEx(const Cv2xStatus &_status, const std::vector< Cv2xPoolStatus > &_poolStatus, const bool &_timeUncertaintyValid, const float &_timeUncertainty)
        {
            std::get< 0>(values_) = _status;
            std::get< 1>(values_) = _poolStatus;
            std::get< 2>(values_) = _timeUncertaintyValid;
            std::get< 3>(values_) = _timeUncertainty;
        }
        inline const Cv2xStatus &getStatus() const { return std::get< 0>(values_); }
        inline void setStatus(const Cv2xStatus &_value) { std::get< 0>(values_) = _value; }
        inline const std::vector< Cv2xPoolStatus > &getPoolStatus() const { return std::get< 1>(values_); }
        inline void setPoolStatus(const std::vector< Cv2xPoolStatus > &_value) { std::get< 1>(values_) = _value; }
        inline const bool &getTimeUncertaintyValid() const { return std::get< 2>(values_); }
        inline void setTimeUncertaintyValid(const bool _value) { std::get< 2>(values_) = _value; }
        inline const float &getTimeUncertainty() const { return std::get< 3>(values_); }
        inline void setTimeUncertainty(const float &_value) { std::get< 3>(values_) = _value; }
        inline bool operator==(const Cv2xStatusEx& _other) const {
        return (getStatus() == _other.getStatus() && getPoolStatus() == _other.getPoolStatus() && getTimeUncertaintyValid() == _other.getTimeUncertaintyValid() && getTimeUncertainty() == _other.getTimeUncertainty());
        }
        inline bool operator!=(const Cv2xStatusEx &_other) const {
            return !((*this) == _other);
        }
    
    };
    
    struct TrafficIpType : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            TRAFFIC_IP = 0,
            TRAFFIC_NON_IP = 1
        };
    
        TrafficIpType()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::TRAFFIC_IP)) {}
        TrafficIpType(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::TRAFFIC_IP):
                case static_cast< uint8_t>(Literal::TRAFFIC_NON_IP):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const TrafficIpType &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const TrafficIpType &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const TrafficIpType &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const TrafficIpType &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const TrafficIpType &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const TrafficIpType &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::TRAFFIC_IP): return "TRAFFIC_IP";
            case static_cast< uint8_t>(Literal::TRAFFIC_NON_IP): return "TRAFFIC_NON_IP";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct RadioConcurrencyMode : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            WWAN_NONCONCURRENT = 0,
            WWAN_CONCURRENT = 1
        };
    
        RadioConcurrencyMode()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::WWAN_NONCONCURRENT)) {}
        RadioConcurrencyMode(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::WWAN_NONCONCURRENT):
                case static_cast< uint8_t>(Literal::WWAN_CONCURRENT):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const RadioConcurrencyMode &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const RadioConcurrencyMode &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const RadioConcurrencyMode &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const RadioConcurrencyMode &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const RadioConcurrencyMode &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const RadioConcurrencyMode &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::WWAN_NONCONCURRENT): return "WWAN_NONCONCURRENT";
            case static_cast< uint8_t>(Literal::WWAN_CONCURRENT): return "WWAN_CONCURRENT";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct Cv2xEvent : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            CV2X_INVACTIVE = 0,
            CV2X_ACTIVE = 1,
            TX_SUSPENDED = 2,
            TXRX_SUSPENDED = 3
        };
    
        Cv2xEvent()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::CV2X_INVACTIVE)) {}
        Cv2xEvent(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::CV2X_INVACTIVE):
                case static_cast< uint8_t>(Literal::CV2X_ACTIVE):
                case static_cast< uint8_t>(Literal::TX_SUSPENDED):
                case static_cast< uint8_t>(Literal::TXRX_SUSPENDED):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const Cv2xEvent &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const Cv2xEvent &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const Cv2xEvent &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const Cv2xEvent &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const Cv2xEvent &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const Cv2xEvent &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::CV2X_INVACTIVE): return "CV2X_INVACTIVE";
            case static_cast< uint8_t>(Literal::CV2X_ACTIVE): return "CV2X_ACTIVE";
            case static_cast< uint8_t>(Literal::TX_SUSPENDED): return "TX_SUSPENDED";
            case static_cast< uint8_t>(Literal::TXRX_SUSPENDED): return "TXRX_SUSPENDED";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct Priority : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            MOST_URGENT = 0,
            PRIORITY_1 = 1,
            PRIORITY_2 = 2,
            PRIORITY_3 = 3,
            PRIORITY_4 = 4,
            PRIORITY_5 = 5,
            PRIORITY_6 = 6,
            PRIORITY_BACKGROUND = 7,
            PRIORITY_UNKNOWN = 8
        };
    
        Priority()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::MOST_URGENT)) {}
        Priority(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::MOST_URGENT):
                case static_cast< uint8_t>(Literal::PRIORITY_1):
                case static_cast< uint8_t>(Literal::PRIORITY_2):
                case static_cast< uint8_t>(Literal::PRIORITY_3):
                case static_cast< uint8_t>(Literal::PRIORITY_4):
                case static_cast< uint8_t>(Literal::PRIORITY_5):
                case static_cast< uint8_t>(Literal::PRIORITY_6):
                case static_cast< uint8_t>(Literal::PRIORITY_BACKGROUND):
                case static_cast< uint8_t>(Literal::PRIORITY_UNKNOWN):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const Priority &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const Priority &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const Priority &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const Priority &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const Priority &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const Priority &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::MOST_URGENT): return "MOST_URGENT";
            case static_cast< uint8_t>(Literal::PRIORITY_1): return "PRIORITY_1";
            case static_cast< uint8_t>(Literal::PRIORITY_2): return "PRIORITY_2";
            case static_cast< uint8_t>(Literal::PRIORITY_3): return "PRIORITY_3";
            case static_cast< uint8_t>(Literal::PRIORITY_4): return "PRIORITY_4";
            case static_cast< uint8_t>(Literal::PRIORITY_5): return "PRIORITY_5";
            case static_cast< uint8_t>(Literal::PRIORITY_6): return "PRIORITY_6";
            case static_cast< uint8_t>(Literal::PRIORITY_BACKGROUND): return "PRIORITY_BACKGROUND";
            case static_cast< uint8_t>(Literal::PRIORITY_UNKNOWN): return "PRIORITY_UNKNOWN";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct Periodicity : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            PERIODICITY_10MS = 0,
            PERIODICITY_20MS = 1,
            PERIODICITY_50MS = 2,
            PERIODICITY_100MS = 3,
            PERIODICITY_UNKNOWN = 4
        };
    
        Periodicity()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::PERIODICITY_10MS)) {}
        Periodicity(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::PERIODICITY_10MS):
                case static_cast< uint8_t>(Literal::PERIODICITY_20MS):
                case static_cast< uint8_t>(Literal::PERIODICITY_50MS):
                case static_cast< uint8_t>(Literal::PERIODICITY_100MS):
                case static_cast< uint8_t>(Literal::PERIODICITY_UNKNOWN):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const Periodicity &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const Periodicity &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const Periodicity &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const Periodicity &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const Periodicity &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const Periodicity &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::PERIODICITY_10MS): return "PERIODICITY_10MS";
            case static_cast< uint8_t>(Literal::PERIODICITY_20MS): return "PERIODICITY_20MS";
            case static_cast< uint8_t>(Literal::PERIODICITY_50MS): return "PERIODICITY_50MS";
            case static_cast< uint8_t>(Literal::PERIODICITY_100MS): return "PERIODICITY_100MS";
            case static_cast< uint8_t>(Literal::PERIODICITY_UNKNOWN): return "PERIODICITY_UNKNOWN";
            default: return "UNDEFINED";
            }
        }
    };
    struct TxPoolIdInfo : CommonAPI::Struct< uint8_t, uint16_t, uint16_t> {
    
        TxPoolIdInfo()
        {
            std::get< 0>(values_) = 0u;
            std::get< 1>(values_) = 0u;
            std::get< 2>(values_) = 0u;
        }
        TxPoolIdInfo(const uint8_t &_poolId, const uint16_t &_minFreq, const uint16_t &_maxFreq)
        {
            std::get< 0>(values_) = _poolId;
            std::get< 1>(values_) = _minFreq;
            std::get< 2>(values_) = _maxFreq;
        }
        inline const uint8_t &getPoolId() const { return std::get< 0>(values_); }
        inline void setPoolId(const uint8_t &_value) { std::get< 0>(values_) = _value; }
        inline const uint16_t &getMinFreq() const { return std::get< 1>(values_); }
        inline void setMinFreq(const uint16_t &_value) { std::get< 1>(values_) = _value; }
        inline const uint16_t &getMaxFreq() const { return std::get< 2>(values_); }
        inline void setMaxFreq(const uint16_t &_value) { std::get< 2>(values_) = _value; }
        inline bool operator==(const TxPoolIdInfo& _other) const {
        return (getPoolId() == _other.getPoolId() && getMinFreq() == _other.getMinFreq() && getMaxFreq() == _other.getMaxFreq());
        }
        inline bool operator!=(const TxPoolIdInfo &_other) const {
            return !((*this) == _other);
        }
    
    };
    struct EventFlowInfo : CommonAPI::Struct< bool, bool, bool, int32_t, bool, uint8_t, bool, uint8_t, bool> {
    
        EventFlowInfo()
        {
            std::get< 0>(values_) = false;
            std::get< 1>(values_) = false;
            std::get< 2>(values_) = false;
            std::get< 3>(values_) = 0;
            std::get< 4>(values_) = false;
            std::get< 5>(values_) = 0u;
            std::get< 6>(values_) = false;
            std::get< 7>(values_) = 0u;
            std::get< 8>(values_) = false;
        }
        EventFlowInfo(const bool &_autoRetransEnabledValid, const bool &_autoRetransEnabled, const bool &_peakTxPowerValid, const int32_t &_peakTxPower, const bool &_mcsIndexValid, const uint8_t &_mcsIndex, const bool &_txPoolIdValid, const uint8_t &_txPoolId, const bool &_isUnicast)
        {
            std::get< 0>(values_) = _autoRetransEnabledValid;
            std::get< 1>(values_) = _autoRetransEnabled;
            std::get< 2>(values_) = _peakTxPowerValid;
            std::get< 3>(values_) = _peakTxPower;
            std::get< 4>(values_) = _mcsIndexValid;
            std::get< 5>(values_) = _mcsIndex;
            std::get< 6>(values_) = _txPoolIdValid;
            std::get< 7>(values_) = _txPoolId;
            std::get< 8>(values_) = _isUnicast;
        }
        inline const bool &getAutoRetransEnabledValid() const { return std::get< 0>(values_); }
        inline void setAutoRetransEnabledValid(const bool _value) { std::get< 0>(values_) = _value; }
        inline const bool &getAutoRetransEnabled() const { return std::get< 1>(values_); }
        inline void setAutoRetransEnabled(const bool _value) { std::get< 1>(values_) = _value; }
        inline const bool &getPeakTxPowerValid() const { return std::get< 2>(values_); }
        inline void setPeakTxPowerValid(const bool _value) { std::get< 2>(values_) = _value; }
        inline const int32_t &getPeakTxPower() const { return std::get< 3>(values_); }
        inline void setPeakTxPower(const int32_t &_value) { std::get< 3>(values_) = _value; }
        inline const bool &getMcsIndexValid() const { return std::get< 4>(values_); }
        inline void setMcsIndexValid(const bool _value) { std::get< 4>(values_) = _value; }
        inline const uint8_t &getMcsIndex() const { return std::get< 5>(values_); }
        inline void setMcsIndex(const uint8_t &_value) { std::get< 5>(values_) = _value; }
        inline const bool &getTxPoolIdValid() const { return std::get< 6>(values_); }
        inline void setTxPoolIdValid(const bool _value) { std::get< 6>(values_) = _value; }
        inline const uint8_t &getTxPoolId() const { return std::get< 7>(values_); }
        inline void setTxPoolId(const uint8_t &_value) { std::get< 7>(values_) = _value; }
        inline const bool &getIsUnicast() const { return std::get< 8>(values_); }
        inline void setIsUnicast(const bool _value) { std::get< 8>(values_) = _value; }
        inline bool operator==(const EventFlowInfo& _other) const {
        return (getAutoRetransEnabledValid() == _other.getAutoRetransEnabledValid() && getAutoRetransEnabled() == _other.getAutoRetransEnabled() && getPeakTxPowerValid() == _other.getPeakTxPowerValid() && getPeakTxPower() == _other.getPeakTxPower() && getMcsIndexValid() == _other.getMcsIndexValid() && getMcsIndex() == _other.getMcsIndex() && getTxPoolIdValid() == _other.getTxPoolIdValid() && getTxPoolId() == _other.getTxPoolId() && getIsUnicast() == _other.getIsUnicast());
        }
        inline bool operator!=(const EventFlowInfo &_other) const {
            return !((*this) == _other);
        }
    
    };
    struct SpsFlowInfo : CommonAPI::Struct< Priority, Periodicity, uint64_t, uint32_t, bool, bool, bool, int32_t, bool, uint8_t, bool, uint8_t> {
    
        SpsFlowInfo()
        {
            std::get< 0>(values_) = Priority();
            std::get< 1>(values_) = Periodicity();
            std::get< 2>(values_) = 0ull;
            std::get< 3>(values_) = 0ul;
            std::get< 4>(values_) = false;
            std::get< 5>(values_) = false;
            std::get< 6>(values_) = false;
            std::get< 7>(values_) = 0;
            std::get< 8>(values_) = false;
            std::get< 9>(values_) = 0u;
            std::get< 10>(values_) = false;
            std::get< 11>(values_) = 0u;
        }
        SpsFlowInfo(const Priority &_priority, const Periodicity &_periodicity, const uint64_t &_periodicityMs, const uint32_t &_nbytesReserved, const bool &_autoRetransEnabledValid, const bool &_autoRetransEnabled, const bool &_peakTxPowerValid, const int32_t &_peakTxPower, const bool &_mcsIndexValid, const uint8_t &_mcsIndex, const bool &_txPoolIdValid, const uint8_t &_txPoolId)
        {
            std::get< 0>(values_) = _priority;
            std::get< 1>(values_) = _periodicity;
            std::get< 2>(values_) = _periodicityMs;
            std::get< 3>(values_) = _nbytesReserved;
            std::get< 4>(values_) = _autoRetransEnabledValid;
            std::get< 5>(values_) = _autoRetransEnabled;
            std::get< 6>(values_) = _peakTxPowerValid;
            std::get< 7>(values_) = _peakTxPower;
            std::get< 8>(values_) = _mcsIndexValid;
            std::get< 9>(values_) = _mcsIndex;
            std::get< 10>(values_) = _txPoolIdValid;
            std::get< 11>(values_) = _txPoolId;
        }
        inline const Priority &getPriority() const { return std::get< 0>(values_); }
        inline void setPriority(const Priority &_value) { std::get< 0>(values_) = _value; }
        inline const Periodicity &getPeriodicity() const { return std::get< 1>(values_); }
        inline void setPeriodicity(const Periodicity &_value) { std::get< 1>(values_) = _value; }
        inline const uint64_t &getPeriodicityMs() const { return std::get< 2>(values_); }
        inline void setPeriodicityMs(const uint64_t &_value) { std::get< 2>(values_) = _value; }
        inline const uint32_t &getNbytesReserved() const { return std::get< 3>(values_); }
        inline void setNbytesReserved(const uint32_t &_value) { std::get< 3>(values_) = _value; }
        inline const bool &getAutoRetransEnabledValid() const { return std::get< 4>(values_); }
        inline void setAutoRetransEnabledValid(const bool _value) { std::get< 4>(values_) = _value; }
        inline const bool &getAutoRetransEnabled() const { return std::get< 5>(values_); }
        inline void setAutoRetransEnabled(const bool _value) { std::get< 5>(values_) = _value; }
        inline const bool &getPeakTxPowerValid() const { return std::get< 6>(values_); }
        inline void setPeakTxPowerValid(const bool _value) { std::get< 6>(values_) = _value; }
        inline const int32_t &getPeakTxPower() const { return std::get< 7>(values_); }
        inline void setPeakTxPower(const int32_t &_value) { std::get< 7>(values_) = _value; }
        inline const bool &getMcsIndexValid() const { return std::get< 8>(values_); }
        inline void setMcsIndexValid(const bool _value) { std::get< 8>(values_) = _value; }
        inline const uint8_t &getMcsIndex() const { return std::get< 9>(values_); }
        inline void setMcsIndex(const uint8_t &_value) { std::get< 9>(values_) = _value; }
        inline const bool &getTxPoolIdValid() const { return std::get< 10>(values_); }
        inline void setTxPoolIdValid(const bool _value) { std::get< 10>(values_) = _value; }
        inline const uint8_t &getTxPoolId() const { return std::get< 11>(values_); }
        inline void setTxPoolId(const uint8_t &_value) { std::get< 11>(values_) = _value; }
        inline bool operator==(const SpsFlowInfo& _other) const {
        return (getPriority() == _other.getPriority() && getPeriodicity() == _other.getPeriodicity() && getPeriodicityMs() == _other.getPeriodicityMs() && getNbytesReserved() == _other.getNbytesReserved() && getAutoRetransEnabledValid() == _other.getAutoRetransEnabledValid() && getAutoRetransEnabled() == _other.getAutoRetransEnabled() && getPeakTxPowerValid() == _other.getPeakTxPowerValid() && getPeakTxPower() == _other.getPeakTxPower() && getMcsIndexValid() == _other.getMcsIndexValid() && getMcsIndex() == _other.getMcsIndex() && getTxPoolIdValid() == _other.getTxPoolIdValid() && getTxPoolId() == _other.getTxPoolId());
        }
        inline bool operator!=(const SpsFlowInfo &_other) const {
            return !((*this) == _other);
        }
    
    };
    struct Cv2xRadioCapabilities : CommonAPI::Struct< uint32_t, uint32_t, RadioConcurrencyMode, uint16_t, uint16_t, uint8_t, std::vector< uint64_t >, uint8_t, uint8_t, uint8_t, uint16_t, uint16_t, int32_t, int32_t, std::vector< TxPoolIdInfo >, uint8_t> {
    
        Cv2xRadioCapabilities()
        {
            std::get< 0>(values_) = 0ul;
            std::get< 1>(values_) = 0ul;
            std::get< 2>(values_) = RadioConcurrencyMode();
            std::get< 3>(values_) = 0u;
            std::get< 4>(values_) = 0u;
            std::get< 5>(values_) = 0u;
            std::get< 6>(values_) = std::vector< uint64_t >();
            std::get< 7>(values_) = 0u;
            std::get< 8>(values_) = 0u;
            std::get< 9>(values_) = 0u;
            std::get< 10>(values_) = 0u;
            std::get< 11>(values_) = 0u;
            std::get< 12>(values_) = 0;
            std::get< 13>(values_) = 0;
            std::get< 14>(values_) = std::vector< TxPoolIdInfo >();
            std::get< 15>(values_) = 0u;
        }
        Cv2xRadioCapabilities(const uint32_t &_linkIpMtuBytes, const uint32_t &_linkNonIpMtuBytes, const RadioConcurrencyMode &_maxSupportedConcurrency, const uint16_t &_nonIpTxPayloadOffsetBytes, const uint16_t &_nonIpRxPayloadOffsetBytes, const uint8_t &_periodicitiesSupported, const std::vector< uint64_t > &_periodicities, const uint8_t &_maxNumAutoRetransmissions, const uint8_t &_layer2MacAddressSize, const uint8_t &_prioritiesSupported, const uint16_t &_maxNumSpsFlows, const uint16_t &_maxNumNonSpsFlows, const int32_t &_maxTxPower, const int32_t &_minTxPower, const std::vector< TxPoolIdInfo > &_txPoolIdsSupported, const uint8_t &_isUnicastSupported)
        {
            std::get< 0>(values_) = _linkIpMtuBytes;
            std::get< 1>(values_) = _linkNonIpMtuBytes;
            std::get< 2>(values_) = _maxSupportedConcurrency;
            std::get< 3>(values_) = _nonIpTxPayloadOffsetBytes;
            std::get< 4>(values_) = _nonIpRxPayloadOffsetBytes;
            std::get< 5>(values_) = _periodicitiesSupported;
            std::get< 6>(values_) = _periodicities;
            std::get< 7>(values_) = _maxNumAutoRetransmissions;
            std::get< 8>(values_) = _layer2MacAddressSize;
            std::get< 9>(values_) = _prioritiesSupported;
            std::get< 10>(values_) = _maxNumSpsFlows;
            std::get< 11>(values_) = _maxNumNonSpsFlows;
            std::get< 12>(values_) = _maxTxPower;
            std::get< 13>(values_) = _minTxPower;
            std::get< 14>(values_) = _txPoolIdsSupported;
            std::get< 15>(values_) = _isUnicastSupported;
        }
        inline const uint32_t &getLinkIpMtuBytes() const { return std::get< 0>(values_); }
        inline void setLinkIpMtuBytes(const uint32_t &_value) { std::get< 0>(values_) = _value; }
        inline const uint32_t &getLinkNonIpMtuBytes() const { return std::get< 1>(values_); }
        inline void setLinkNonIpMtuBytes(const uint32_t &_value) { std::get< 1>(values_) = _value; }
        inline const RadioConcurrencyMode &getMaxSupportedConcurrency() const { return std::get< 2>(values_); }
        inline void setMaxSupportedConcurrency(const RadioConcurrencyMode &_value) { std::get< 2>(values_) = _value; }
        inline const uint16_t &getNonIpTxPayloadOffsetBytes() const { return std::get< 3>(values_); }
        inline void setNonIpTxPayloadOffsetBytes(const uint16_t &_value) { std::get< 3>(values_) = _value; }
        inline const uint16_t &getNonIpRxPayloadOffsetBytes() const { return std::get< 4>(values_); }
        inline void setNonIpRxPayloadOffsetBytes(const uint16_t &_value) { std::get< 4>(values_) = _value; }
        inline const uint8_t &getPeriodicitiesSupported() const { return std::get< 5>(values_); }
        inline void setPeriodicitiesSupported(const uint8_t &_value) { std::get< 5>(values_) = _value; }
        inline const std::vector< uint64_t > &getPeriodicities() const { return std::get< 6>(values_); }
        inline void setPeriodicities(const std::vector< uint64_t > &_value) { std::get< 6>(values_) = _value; }
        inline const uint8_t &getMaxNumAutoRetransmissions() const { return std::get< 7>(values_); }
        inline void setMaxNumAutoRetransmissions(const uint8_t &_value) { std::get< 7>(values_) = _value; }
        inline const uint8_t &getLayer2MacAddressSize() const { return std::get< 8>(values_); }
        inline void setLayer2MacAddressSize(const uint8_t &_value) { std::get< 8>(values_) = _value; }
        inline const uint8_t &getPrioritiesSupported() const { return std::get< 9>(values_); }
        inline void setPrioritiesSupported(const uint8_t &_value) { std::get< 9>(values_) = _value; }
        inline const uint16_t &getMaxNumSpsFlows() const { return std::get< 10>(values_); }
        inline void setMaxNumSpsFlows(const uint16_t &_value) { std::get< 10>(values_) = _value; }
        inline const uint16_t &getMaxNumNonSpsFlows() const { return std::get< 11>(values_); }
        inline void setMaxNumNonSpsFlows(const uint16_t &_value) { std::get< 11>(values_) = _value; }
        inline const int32_t &getMaxTxPower() const { return std::get< 12>(values_); }
        inline void setMaxTxPower(const int32_t &_value) { std::get< 12>(values_) = _value; }
        inline const int32_t &getMinTxPower() const { return std::get< 13>(values_); }
        inline void setMinTxPower(const int32_t &_value) { std::get< 13>(values_) = _value; }
        inline const std::vector< TxPoolIdInfo > &getTxPoolIdsSupported() const { return std::get< 14>(values_); }
        inline void setTxPoolIdsSupported(const std::vector< TxPoolIdInfo > &_value) { std::get< 14>(values_) = _value; }
        inline const uint8_t &getIsUnicastSupported() const { return std::get< 15>(values_); }
        inline void setIsUnicastSupported(const uint8_t &_value) { std::get< 15>(values_) = _value; }
        inline bool operator==(const Cv2xRadioCapabilities& _other) const {
        return (getLinkIpMtuBytes() == _other.getLinkIpMtuBytes() && getLinkNonIpMtuBytes() == _other.getLinkNonIpMtuBytes() && getMaxSupportedConcurrency() == _other.getMaxSupportedConcurrency() && getNonIpTxPayloadOffsetBytes() == _other.getNonIpTxPayloadOffsetBytes() && getNonIpRxPayloadOffsetBytes() == _other.getNonIpRxPayloadOffsetBytes() && getPeriodicitiesSupported() == _other.getPeriodicitiesSupported() && getPeriodicities() == _other.getPeriodicities() && getMaxNumAutoRetransmissions() == _other.getMaxNumAutoRetransmissions() && getLayer2MacAddressSize() == _other.getLayer2MacAddressSize() && getPrioritiesSupported() == _other.getPrioritiesSupported() && getMaxNumSpsFlows() == _other.getMaxNumSpsFlows() && getMaxNumNonSpsFlows() == _other.getMaxNumNonSpsFlows() && getMaxTxPower() == _other.getMaxTxPower() && getMinTxPower() == _other.getMinTxPower() && getTxPoolIdsSupported() == _other.getTxPoolIdsSupported() && getIsUnicastSupported() == _other.getIsUnicastSupported());
        }
        inline bool operator!=(const Cv2xRadioCapabilities &_other) const {
            return !((*this) == _other);
        }
    
    };
    struct MacDetails : CommonAPI::Struct< uint32_t, uint16_t, uint32_t> {
    
        MacDetails()
        {
            std::get< 0>(values_) = 0ul;
            std::get< 1>(values_) = 0u;
            std::get< 2>(values_) = 0ul;
        }
        MacDetails(const uint32_t &_periodicityInUseNs, const uint16_t &_currentlyReservedPeriodicBytes, const uint32_t &_txReservationOffsetNs)
        {
            std::get< 0>(values_) = _periodicityInUseNs;
            std::get< 1>(values_) = _currentlyReservedPeriodicBytes;
            std::get< 2>(values_) = _txReservationOffsetNs;
        }
        inline const uint32_t &getPeriodicityInUseNs() const { return std::get< 0>(values_); }
        inline void setPeriodicityInUseNs(const uint32_t &_value) { std::get< 0>(values_) = _value; }
        inline const uint16_t &getCurrentlyReservedPeriodicBytes() const { return std::get< 1>(values_); }
        inline void setCurrentlyReservedPeriodicBytes(const uint16_t &_value) { std::get< 1>(values_) = _value; }
        inline const uint32_t &getTxReservationOffsetNs() const { return std::get< 2>(values_); }
        inline void setTxReservationOffsetNs(const uint32_t &_value) { std::get< 2>(values_) = _value; }
        inline bool operator==(const MacDetails& _other) const {
        return (getPeriodicityInUseNs() == _other.getPeriodicityInUseNs() && getCurrentlyReservedPeriodicBytes() == _other.getCurrentlyReservedPeriodicBytes() && getTxReservationOffsetNs() == _other.getTxReservationOffsetNs());
        }
        inline bool operator!=(const MacDetails &_other) const {
            return !((*this) == _other);
        }
    
    };
    struct SpsSchedulingInfo : CommonAPI::Struct< uint8_t, uint64_t, uint32_t> {
    
        SpsSchedulingInfo()
        {
            std::get< 0>(values_) = 0u;
            std::get< 1>(values_) = 0ull;
            std::get< 2>(values_) = 0ul;
        }
        SpsSchedulingInfo(const uint8_t &_spsId, const uint64_t &_utcTime, const uint32_t &_periodicity)
        {
            std::get< 0>(values_) = _spsId;
            std::get< 1>(values_) = _utcTime;
            std::get< 2>(values_) = _periodicity;
        }
        inline const uint8_t &getSpsId() const { return std::get< 0>(values_); }
        inline void setSpsId(const uint8_t &_value) { std::get< 0>(values_) = _value; }
        inline const uint64_t &getUtcTime() const { return std::get< 1>(values_); }
        inline void setUtcTime(const uint64_t &_value) { std::get< 1>(values_) = _value; }
        inline const uint32_t &getPeriodicity() const { return std::get< 2>(values_); }
        inline void setPeriodicity(const uint32_t &_value) { std::get< 2>(values_) = _value; }
        inline bool operator==(const SpsSchedulingInfo& _other) const {
        return (getSpsId() == _other.getSpsId() && getUtcTime() == _other.getUtcTime() && getPeriodicity() == _other.getPeriodicity());
        }
        inline bool operator!=(const SpsSchedulingInfo &_other) const {
            return !((*this) == _other);
        }
    
    };
    struct TrustedUEInfo : CommonAPI::Struct< uint32_t, float, uint16_t, uint16_t, uint32_t> {
    
        TrustedUEInfo()
        {
            std::get< 0>(values_) = 0ul;
            std::get< 1>(values_) = 0.0f;
            std::get< 2>(values_) = 0u;
            std::get< 3>(values_) = 0u;
            std::get< 4>(values_) = 0ul;
        }
        TrustedUEInfo(const uint32_t &_sourceL2Id, const float &_timeUncertainty, const uint16_t &_timeConfidenceLevel, const uint16_t &_positionConfidenceLevel, const uint32_t &_propagationDelay)
        {
            std::get< 0>(values_) = _sourceL2Id;
            std::get< 1>(values_) = _timeUncertainty;
            std::get< 2>(values_) = _timeConfidenceLevel;
            std::get< 3>(values_) = _positionConfidenceLevel;
            std::get< 4>(values_) = _propagationDelay;
        }
        inline const uint32_t &getSourceL2Id() const { return std::get< 0>(values_); }
        inline void setSourceL2Id(const uint32_t &_value) { std::get< 0>(values_) = _value; }
        inline const float &getTimeUncertainty() const { return std::get< 1>(values_); }
        inline void setTimeUncertainty(const float &_value) { std::get< 1>(values_) = _value; }
        inline const uint16_t &getTimeConfidenceLevel() const { return std::get< 2>(values_); }
        inline void setTimeConfidenceLevel(const uint16_t &_value) { std::get< 2>(values_) = _value; }
        inline const uint16_t &getPositionConfidenceLevel() const { return std::get< 3>(values_); }
        inline void setPositionConfidenceLevel(const uint16_t &_value) { std::get< 3>(values_) = _value; }
        inline const uint32_t &getPropagationDelay() const { return std::get< 4>(values_); }
        inline void setPropagationDelay(const uint32_t &_value) { std::get< 4>(values_) = _value; }
        inline bool operator==(const TrustedUEInfo& _other) const {
        return (getSourceL2Id() == _other.getSourceL2Id() && getTimeUncertainty() == _other.getTimeUncertainty() && getTimeConfidenceLevel() == _other.getTimeConfidenceLevel() && getPositionConfidenceLevel() == _other.getPositionConfidenceLevel() && getPropagationDelay() == _other.getPropagationDelay());
        }
        inline bool operator!=(const TrustedUEInfo &_other) const {
            return !((*this) == _other);
        }
    
    };
    struct TrustedUEInfoList : CommonAPI::Struct< bool, std::vector< uint32_t >, bool, std::vector< TrustedUEInfo >> {
    
        TrustedUEInfoList()
        {
            std::get< 0>(values_) = false;
            std::get< 1>(values_) = std::vector< uint32_t >();
            std::get< 2>(values_) = false;
            std::get< 3>(values_) = std::vector< TrustedUEInfo >();
        }
        TrustedUEInfoList(const bool &_maliciousIdsValid, const std::vector< uint32_t > &_maliciousIds, const bool &_trustedUEsValid, const std::vector< TrustedUEInfo > &_trustedUEs)
        {
            std::get< 0>(values_) = _maliciousIdsValid;
            std::get< 1>(values_) = _maliciousIds;
            std::get< 2>(values_) = _trustedUEsValid;
            std::get< 3>(values_) = _trustedUEs;
        }
        inline const bool &getMaliciousIdsValid() const { return std::get< 0>(values_); }
        inline void setMaliciousIdsValid(const bool _value) { std::get< 0>(values_) = _value; }
        inline const std::vector< uint32_t > &getMaliciousIds() const { return std::get< 1>(values_); }
        inline void setMaliciousIds(const std::vector< uint32_t > &_value) { std::get< 1>(values_) = _value; }
        inline const bool &getTrustedUEsValid() const { return std::get< 2>(values_); }
        inline void setTrustedUEsValid(const bool _value) { std::get< 2>(values_) = _value; }
        inline const std::vector< TrustedUEInfo > &getTrustedUEs() const { return std::get< 3>(values_); }
        inline void setTrustedUEs(const std::vector< TrustedUEInfo > &_value) { std::get< 3>(values_) = _value; }
        inline bool operator==(const TrustedUEInfoList& _other) const {
        return (getMaliciousIdsValid() == _other.getMaliciousIdsValid() && getMaliciousIds() == _other.getMaliciousIds() && getTrustedUEsValid() == _other.getTrustedUEsValid() && getTrustedUEs() == _other.getTrustedUEs());
        }
        inline bool operator!=(const TrustedUEInfoList &_other) const {
            return !((*this) == _other);
        }
    
    };
};

const char* Cv2xRadioTypes::getInterface() {
    return ("commonapi.telux.cv2x.Cv2xRadioTypes:v1_0");
}

CommonAPI::Version Cv2xRadioTypes::getInterfaceVersion() {
    return CommonAPI::Version(1, 0);
}


} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1

namespace CommonAPI {
}


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_TELUX_CV2X_CV2X_RADIO_TYPES_HPP_
